package com.xypower.wpywapp;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import android.content.Intent;
import android.location.Location;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import com.tananaev.adblib.AdbConnection;
import com.tananaev.adblib.AdbCrypto;
import com.tananaev.adblib.AdbStream;
import com.xypower.wpywapp.bean.TerminalBean;
import com.xypower.wpywapp.databinding.ActivityMainBinding;
import com.xypower.wpywapp.interfaces.MainActCallback;
import com.xypower.wpywapp.jadb.JadbDevice;
import com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbConnectionManager;
import com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbInputStream;
import com.xypower.wpywapp.tool.LocationUtil;
import com.xypower.wpywapp.ui.BottomActivity;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;


/*
这三个文件夹下日志的清除
* /var/log/xymp/xymanagerLogs
* /var/log/xymp/logs
* /usr/local/share/tomcat/logs/



这个文件日志的切割
/usr/local/share/tomcat/logs/catalina.out
*
* */
public class MainActivity extends AppCompatActivity {

    private JadbDevice jadbDevice;
    private TerminalBean bean = new TerminalBean();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ActivityMainBinding binding = DataBindingUtil.setContentView(this, R.layout.activity_main);
        bean.setVerion("未知");
        bean.setSim("未知");
        bean.setPower("未知");
        binding.setBean(bean);
        Handler handler = new Handler() {
            @Override
            public void handleMessage(@NonNull Message msg) {
                super.handleMessage(msg);
                if (msg.what == 1) {
                    Toast.makeText(MainActivity.this, "1111", Toast.LENGTH_SHORT).show();
                } else if (msg.what == 2) {
                    Toast.makeText(MainActivity.this, "2222", Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(MainActivity.this, "3333", Toast.LENGTH_SHORT).show();
                }
            }
        };
        binding.setCallback(new MainActCallback() {
            @Override
            public void link(View view) {

                LocationUtil.register(MainActivity.this, 0, 0, new LocationUtil.OnLocationChangeListener() {
                    @Override
                    public void getLastKnownLocation(Location location) {
                        Log.e("xyh", "onLocationChanged: " + location.getLatitude());
                    }

                    @Override
                    public void onLocationChanged(Location location) {
                        //位置信息变化时触发
                        Log.e("xyh", "定位方式：" + location.getProvider());
                        Log.e("xyh", "纬度：" + location.getLatitude());
                        Log.e("xyh", "经度：" + location.getLongitude());
                        Log.e("xyh", "海拔：" + location.getAltitude());
                        Log.e("xyh", "时间：" + location.getTime());
                        Log.e("xyh", "国家：" + LocationUtil.getCountryName(MainActivity.this, location.getLatitude(), location.getLongitude()));
                        Log.e("xyh", "获取地理位置：" + LocationUtil.getAddress(MainActivity.this, location.getLatitude(), location.getLongitude()));
                        Log.e("xyh", "所在地：" + LocationUtil.getLocality(MainActivity.this, location.getLatitude(), location.getLongitude()));
                        Log.e("xyh", "所在街道：" + LocationUtil.getStreet(MainActivity.this, location.getLatitude(), location.getLongitude()));

                    }

                    @Override
                    public void onStatusChanged(String provider, int status, Bundle extras) {
                        System.out.println("dfsad");
                    }
                });


                //连接设备

//                Intent intent = new Intent(MainActivity.this, BottomActivity.class);
//                startActivity(intent);
//                String s = binding.ip.getText().toString();
//                if (RegexUtil.checkIpAddress(s)) {
                //获取可adb调试的设备列表
//                new Thread(new Runnable() {
//                    @Override
//                    public void run() {
////                        try {
//////                                Process process = Runtime.getRuntime().exec("adb shell devices");
//////                                int i = process.waitFor();
//////                                if (i == 0) {
//////                                    InputStream inputStream = process.getInputStream();
//////                                    System.out.println("2312");
//////                                } else {
//////                                    InputStream errorStream = process.getErrorStream();
//////                                    System.out.println("888484");
//////                                }
//////                                AdbServer adbServer = new AdbServer(new AdbResponder() {
//////                                    @Override
//////                                    public void onCommand(String command) {
//////                                        Toast.makeText(MainActivity.this,"cehgnogn1",Toast.LENGTH_SHORT).show();
//////                                    }
//////
//////                                    @Override
//////                                    public int getVersion() {
//////                                        Toast.makeText(MainActivity.this,"cehgnogn3",Toast.LENGTH_SHORT).show();
//////                                        return 0;
//////                                    }
//////
//////                                    @Override
//////                                    public List<AdbDeviceResponder> getDevices() {
//////                                        Toast.makeText(MainActivity.this,"cehgnogn2",Toast.LENGTH_SHORT).show();
//////                                        return null;
//////                                    }
//////                                });
//////                                Runnable responder = adbServer.createResponder(new Socket("127.0.0.1", 15037));
//////                                responder.run();
//////                                JadbConnection jadb = new JadbConnection("192.168.0.100",5555);
////                            JadbConnection jadb = new JadbConnection("192.168.0.118", 5555);
//////                                JadbConnection jadb = new JadbConnection("127.0.0.1", 5555);
//////                                InetSocketAddress inetSocketAddress = jadb.connectToTcpDevice(new InetSocketAddress("192.168.0.101",5555));
//////                                Message msg1 = new Message();
//////                                msg1.what = 3;
//////                                handler.sendMessage(msg1);
//////                                System.out.println(inetSocketAddress);
////                            List<JadbDevice> devices = jadb.getDevices();
////                            jadbDevice = devices.get(0);
//////                                jadbDevice.pull();
////                        } catch (IOException e) {
////                            throw new RuntimeException(e);
////                        } catch (JadbException e) {
////                            throw new RuntimeException(e);
//////                            } catch (ConnectionToRemoteDeviceException e) {
//////                                throw new RuntimeException(e);
////                        }
//
//
//
////                        JadbConnection jadbConnection = new JadbConnection();
////                        List<JadbDevice> anyDevice = null;
////                        try {
////                            InetSocketAddress inetSocketAddress = jadbConnection.connectToTcpDevice(new InetSocketAddress("192.168.0.118",5555));
////                            List<JadbDevice> devices = jadbConnection.getDevices();
////                            JadbDevice jadbDevice = devices.get(1);
////                            RemoteFile remoteFile = new RemoteFile("/storage/emulated/0/iport_log.txt");
////                            String absolutePath = getFilesDir().getAbsolutePath();
////                            jadbDevice.pull(remoteFile,new File(absolutePath+"/a.txt"));
////                            System.out.println(inetSocketAddress);
////                            System.out.println(devices);
//////            anyDevice = jadbConnection.getDevices();
////                        } catch (IOException e) {
////                            e.printStackTrace();
////                        } catch (JadbException e) {
////                            e.printStackTrace();
//////        } catch (ConnectionToRemoteDeviceException e) {
////                            e.printStackTrace();
////                        } catch (ConnectionToRemoteDeviceException e) {
////                            e.printStackTrace();
////
////                        }
//
//
////                        try {
////                            if(Runtime.getRuntime().exec(new String[]{"adb", "version"}).waitFor()!=0){
////                                System.out.println("dfsd");
////                            }
////                        } catch (IOException e) {
////                            throw new RuntimeException(e);
////                        } catch (InterruptedException e) {
////                            throw new RuntimeException(e);
////                        }
//
//
//                    }
//                }).start();
//                } else {
//                    Toast.makeText(MainActivity.this, "IP不合法", Toast.LENGTH_SHORT).show();
//                }
//                asyncTask.execute();
            }

            @Override
            public void getInfo(View view) {

                new Thread(new Runnable() {
                    @Override
                    public void run() {
//                        ADBService adbService = new ADBServiceImpl();
////                        adbService.pullFile()
//                        try {
//                            List<String> connectedDevicesUdid = adbService.getConnectedDevicesUdid();
//                            System.out.println(connectedDevicesUdid);
//                        } catch (Exception e) {
//                            throw new RuntimeException(e);
//                        }


                        try {
                            boolean connect = AdbConnectionManager.getInstance(MainActivity.this).connect("192.168.50.109", 5555);
                            if (connect) {
//                                /storage/emulated/0/i1/log/2024_04_21_yunWei.log
                                String absolutePath = getFilesDir().getAbsolutePath();
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream1 = AdbConnectionManager.getInstance(MainActivity.this).openStream("shell: exit");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("pull: /storage/emulated/0/i1/log/2024_04_21_yunWei.log "+absolutePath+"/");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("shell: date");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbConnection adbConnection = AdbConnectionManager.getInstance(MainActivity.this).getAdbConnection();
//                               ("pull: /storage/emulated/0/i1/log/2024_04_21_yunWei.log "+absolutePath+"/");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream open = adbConnection.open("sync: recv /storage/emulated/0/i1/iport_log.txt  "+absolutePath+"/");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("sync: recv: /storage/emulated/0/i1/iport_log.txt  "+absolutePath+"/");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("shell:cat /storage/emulated/0/iport_log.txt");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("shell:cat /storage/emulated/0/iport_log.txt");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("shell:cp /storage/emulated/0/iport_log.txt "+absolutePath+"/aa.txt");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream2 = AdbConnectionManager.getInstance(MainActivity.this).openStream("sync:");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream1 = AdbConnectionManager.getInstance(MainActivity.this).openStream(LocalServices.SYNC);
//                                adbStream1.flush();
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("shell: sync send /storage/emulated/0/ "+absolutePath+"/324.txt");
//                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("sync:"+"\n" +"recv: /storage/emulated/0/i1/iport_log.txt");
                                com.xypower.wpywapp.libadb.src.main.java.io.github.muntashirakon.adb.AdbStream adbStream = AdbConnectionManager.getInstance(MainActivity.this).openStream("sync:"+"\n" +"recv: /storage/emulated/0/i1/iport_log.txt");
//                                byte[] b = new byte[4];
//                                AdbInputStream adbInputStream = adbStream.openInputStream();
                                AdbInputStream adbInputStream = adbStream.openInputStream();

//

                                String result = null;
                                BufferedReader reader = new BufferedReader(new InputStreamReader(adbInputStream));
                                String line = null;
                                StringBuffer sb = new StringBuffer();
                                while ((line = reader.readLine()) != null) {
                                    sb.append(line);
                                }
                                result = sb.toString();

//                                int off = 0;
//                                int n = 0;
//                                int len = b.length;
//                                while (n < len) {
//                                    int count = adbInputStream.read(b, off + n, len - n);
//                                    if (count < 0)
//                                        throw new EOFException();
//                                    n += count;
//                                }

                                System.out.println(result);
                            }
                        } catch (Exception e) {
                            try {
                                AdbConnectionManager.getInstance(MainActivity.this).disconnect();
                            } catch (Exception ex) {
                                throw new RuntimeException(ex);
                            }
                            throw new RuntimeException(e);
                        }

//                        try {
//                            Process process = Runtime.getRuntime().exec("version");
//                            int i = process.waitFor();
//                            if (i == 0) {
//                                InputStream inputStream = process.getInputStream();
//                                System.out.println("2312");
//                            } else {
//                                InputStream errorStream = process.getErrorStream();
//                                System.out.println("888484");
//                            }
////                                JadbConnection jadb = new JadbConnection(s, 5555);
////                                List<JadbDevice> devices = jadb.getDevices();
////                                jadbDevice = devices.get(0);
//                        } catch (IOException e) {
//                            throw new RuntimeException(e);
//                        } catch (InterruptedException e) {
//                            throw new RuntimeException(e);
//                        }
                    }
                }).start();

                //获取设备信息
//                try {
//                    if (jadbDevice != null) {
//                        jadbDevice.pull(new RemoteFile("/path/to/file.txt"), new File("file.txt"));
//                        //解析文件  将文件的值赋给bean对象
//                        binding.setBean(bean);
//                    }
//                } catch (IOException e) {
//                    throw new RuntimeException(e);
//                } catch (JadbException e) {
//                    throw new RuntimeException(e);
//                }
            }

            @Override
            public void takePic(View view) {

                new Thread(new Runnable() {
                    @Override
                    public void run() {


                        Socket socket = null;
                        AdbCrypto crypto = new AdbCrypto();
                        AdbConnection adbConnection = null;
                        try {
//                            Message msg = new Message();
//                            msg.what = 1;
//                            handler.sendMessage(msg);
                            socket = new Socket("192.168.0.101", 5037);
//                            Message msg1 = new Message();
//                            msg1.what = 3;
//                            handler.sendMessage(msg1);
//                        handler.sendMessage(new Message());
                            adbConnection = AdbConnection.create(socket, crypto);
                            adbConnection.connect();
                            Message msg1 = new Message();
                            msg1.what = 3;
                            handler.sendMessage(msg1);
                            System.out.println("dsadADas");
                            AdbStream fsda = adbConnection.open("devices");
                            System.out.println("rewrewrew");
                        } catch (IOException e) {
                            Message msg = new Message();
                            msg.what = 2;
                            handler.sendMessage(msg);
//                            throw new RuntimeException(e);
                        } catch (InterruptedException e) {
                            throw new RuntimeException(e);
                        }
                    }
                }).start();


//                CommandResult adbDevices = ShellUtils.execCommand("adb version", false);
//                System.out.println(adbDevices.errorMsg);
//                 testCmd.runAdbCommand("version");
//                System.out.println(s);
//                boolean b = testCmd.haveRoot();
//                if (b) {
//
//                }
//                if (jadbDevice != null) {
                //手动拍照
//                    jadbDevice.buildCmdLine("手动拍照");
//                }
            }
        });


    }

    public boolean runRootCommand(String command) {
        Process process = null;
        DataOutputStream os = null;
        try {
            process = Runtime.getRuntime().exec("su");
            os = new DataOutputStream(process.getOutputStream());
            os.writeBytes(command + "\n");
            os.writeBytes("exit\n");
            os.flush();
            process.waitFor();
        } catch (Exception e) {
            return false;
        } finally {
            try {
                if (os != null) {
                    os.close();
                }
                process.destroy();
            } catch (Exception e) {
            }
        }
        return true;
    }
}